typedef unsigned char byte;
typedef byte* BYTEP;

#define bit8    8L        /* The number of bits in a byte */

#define mbitRead(value, bit) (((value) >> (bit)) & 0x01)
#define mbitSet(value, bit) ((value) |= (1UL << (bit)))
#define mbitClear(value, bit) ((value) &= ~(1UL << (bit)))
#define mbitWrite(value, bit, bitvalue) (bitvalue ? mbitSet(value, bit) : mbitClear(value, bit))

#define bitInByte(bit)	        /* Returns the bit mask of a byte */ \
    (1L << (((bit) % bit8)))

#define bitInWord(bit)	        /* Returns the bit mask of a word */ \
    (1L << (((bit) % (bit8 * 2L))))

#define bitInLong(bit)	        /* Returns the bit mask of a long */ \
    (1L << (((bit) % (bit8 * 4L))))

#define byteInArray(array,x)	/* Returns the byte offset to get to a bit */ \
	 ((BYTEP)&(array)[x / bit8])

#define bitIsTrue(array,x)    /* Test to see if a specific bit is True */ \
    (*(byteInArray(array,x)) & bitInByte(+x % bit8))

#define bitIsFalse(array,bit)   /* Test to see if a specific bit is False */ \
    (!(bitIsTrue(array,bit)))

#define bitTrue(array,x)      /* Set a specific bit to be True */ \
    (*(byteInArray(array,x)) |= bitInByte(+x % bit8))

#define bitFalse(array,x)     /* Set a specific bit to be False */ \
	 (*(byteInArray(array,x)) &= ~bitInByte(+x % bit8))
//    (byteInArray(array,bit) &= ~bitInByte(bit))

#define bitToggle(array,bit)    /* Toggle a specific bit */ \
    (byteInArray(array,bit) ^= bitInByte(bit))

#define bitValue(array,x)     /* Return True or False depending on bit */ \
    (bitIsTrue((array),(x)) ? 1 : 0)

#define bitPut(array,x,value) /* Set bit to given value in array */ \
	  (value) ? bitTrue((array),(x)) : bitFalse((array),(x))
